
function GetTempFileName( name )
{
	var tmp = moi.filesystem.getTempDir();
	return tmp + Math.round( ( Math.random() * 0xFFFFFF ) ).toString( 16 ) + '_moi_temp.pdf' ;
}

function Param( name )
{
	return '"' + moi.filesystem.toNativePath(name) + '"';
}

function DoAddPageToPDF()
{
	var base_filename = moi.filesystem.getSaveFileName( 'Add page to PDF', 'PDF files (*.pdf)|*.pdf' );
	if ( base_filename == '' )
		return;

	if ( !moi.filesystem.fileExists( base_filename ) )
	{
		moi.geometryDatabase.saveAs( base_filename );
		return;
	}


	var podofomerge = moi.filesystem.getAppDataDir() + 'tools/podofomerge.exe';
	if ( !moi.filesystem.fileExists( podofomerge ) )
	{
		podofomerge = moi.filesystem.getAppDataDir() + 'tools/podofomerge';
		if ( !moi.filesystem.fileExists( podofomerge ) )
		{
			moi.ui.alert( 'error - podofomerge not found in appdata tools folder' );
			return;
		}
	}


	var newpage_filename = GetTempFileName();
	var combined_filename = GetTempFileName();


	// Generate PDF file with new page in it.
	moi.geometryDatabase.saveAs( newpage_filename );


	// Execute podofomerge to make combined file.
	var Params = Param( base_filename ) + ' ' +Param( newpage_filename ) + ' ' +Param( combined_filename );
	var ret = moi.filesystem.shellExecute( '"' + moi.filesystem.toNativePath(podofomerge) + '"', Params, true /*WaitForFinished*/ );

    //moi.ui.alert( ret.exitCode );
    //moi.ui.alert( ret.output );
    
    
	// Replace base file with combined one.
	if ( moi.filesystem.fileExists( combined_filename ) )
    {
        moi.filesystem.deleteFile( base_filename );
		moi.filesystem.copyFile( combined_filename, base_filename );
    }


	// Clean up temp files.
	moi.filesystem.deleteFile( newpage_filename );
	moi.filesystem.deleteFile( combined_filename );
}

DoAddPageToPDF();
