// config: norepeat

#include "GetObjects.js"
#include "WaitForDialogDone.js"

function DoBatchRename()
{
	var objectpicker = moi.ui.createObjectPicker();
	if ( !GetObjects( objectpicker ) )
		return;
		
	var objects = objectpicker.objects;

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectObjectsPrompt' );
	moi.ui.showUI( 'WriteTextFilePrompt' );
	moi.ui.endUIUpdate();

	var filename = moi.filesystem.getSaveFileName( 'Text file name', 'Text files (*.txt)|*.txt' );
	if ( filename == '' )
		return;


	var names = [];
	var seen_names = [];
	for ( var i = 0; i < objects.length; ++i )
	{
		var name = objects.item(i).name;
		if ( name == '' || seen_names[name] )
			continue;

		names.push( name );
		seen_names[ name ] = true;
	}

	names.sort();

	var outfile = moi.filesystem.openFileStream( filename, 'w' );
	for ( var i = 0; i < names.length; ++i )
		outfile.writeLine( names[i] );

	outfile.close();


	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'WriteTextFilePrompt' );
	moi.ui.showUI( 'EditTextFilePrompt' );
	moi.ui.endUIUpdate();
	if ( !WaitForDialogDone() )
		return;


	var new_names = [];
	var infile = moi.filesystem.openFileStream( filename, 'r' );
	while ( !infile.atEOF )
		new_names.push( infile.readLine() );

	if ( names.length != new_names.length )
	{
		moi.ui.alert( 'Error - edited file does not have the same number of lines' );
		return;
	}

	var remap_names = [];
	for ( var i = 0; i < names.length; ++i )
		remap_names[ names[i] ] = new_names[i];

	// Can be enabled after next v4 beta release.
	//moi.command.addSelectedObjectsStateUndoUnit();

	for ( var i = 0; i < objects.length; ++i )
	{
		var obj = objects.item(i);
		var name = obj.name;
		if ( name == '' )
			continue;

		obj.name = remap_names[ name ];
	}
}

DoBatchRename();
