// config: norepeat

#include "GetObjects.js"

function linie(pt0,pt1)
{
            var LineFactory = moi.command.createFactory( 'line' );
            LineFactory.setInput( 0, pt0);
            LineFactory.setInput( 1, pt1);
            LineFactory.calculate();
            LineFactory.update();
            LineFactory.commit();
}

function magnitude(vec)
{
	var mag;
	mag=Math.sqrt(vec.x*vec.x+vec.y*vec.y+vec.z*vec.z);
return mag;
}

function scale_vector(vec,factor)
{
        var s_vec=moi.vectorMath.createPoint();
        s_vec.x=vec.x*factor;
        s_vec.y=vec.y*factor;
        s_vec.z=vec.z*factor;
        return s_vec;
}

function add_vector(vec_1,vec_2)
{
        var erg=moi.vectorMath.createPoint();
	erg.x= vec_1.x+vec_2.x;
	erg.y= vec_1.y+vec_2.y;
	erg.z= vec_1.z+vec_2.z;
        return erg;
}
function scalar_product(vec_1,vec_2)
{
        var prod = vec_1.x*vec_2.x + vec_1.y*vec_2.y + vec_1.z*vec_2.z;
        return prod;
}

function cross_product(vec_1,vec_2)
{       var prod=moi.vectorMath.createPoint();
        prod.x=vec_1.y*vec_2.z-vec_1.z*vec_2.y;
        prod.y=vec_1.z*vec_2.x-vec_1.x*vec_2.z;
        prod.z=vec_1.x*vec_2.y-vec_1.y*vec_2.x;
        return prod;
}

function csp(p0,p1,p2)
//function csp(p0x,p0y,p0z,p1x,p1y,p1z,p2x,p2y,p2z)
{ 
//	var p0 = moi.vectorMath.createPoint(p0x,p0y,p0z);
//	var p1 = moi.vectorMath.createPoint(p1x,p1y,p1z);
//	var p2 = moi.vectorMath.createPoint(p2x,p2y,p2z);
////////////////////////////////////////////////////
        var sp=moi.vectorMath.createPoint(); //corrospondierender Punkt zu p1
        var vec_p0_1=moi.vectorMath.createPoint(p1.x-p0.x,p1.y-p0.y,p1.z-p0.z); //Richtungsvektor P0-P1
        var vec_p1_2=moi.vectorMath.createPoint(p2.x-p1.x,p2.y-p1.y,p2.z-p1.z); //Richtungsvektor P1-P2
        var n_vec=cross_product(vec_p0_1,vec_p1_2); 	//Normalenvektor der Ebene P0,P1,P2 und Richtungsvektor des Schnitts
        var pPlane_1=add_vector(scale_vector(vec_p0_1,0.5),p0); 	//Punkt des ersten Ebene
	var pPlane_2=add_vector(scale_vector(vec_p1_2,0.5),p1);
 //       var n0_vec=moi.vectorMath.createPoint();
         var betrag=magnitude(n_vec);
//         n0_vec=scale_vector(n_vec,(1/betrag));
            
           // var n0_1=scale_vector(vec_p0_1,(1/magnitude(vec_p0_1)));
            //var n0_2=scale_vector(vec_p1_2,(1/magnitude(vec_p1_2)));
	    //var d_1=scalar_product(n0_1,pPlane_1);
            //var d_2=scalar_product(n0_2,pPlane_2);
	    //var d_3=scalar_product(n0_vec,p1);
            var d_1=scalar_product(vec_p0_1,pPlane_1);
            var d_2=scalar_product(vec_p1_2,pPlane_2);
	    var d_3=scalar_product(n_vec,p1);
/*
        var sp=moi.vectorMath.createPoint(); //corrospondierender Punkt zu p1
        var vec_p0_1=moi.vectorMath.createPoint(p1.x-p0.x,p1.y-p0.y,p1.z-p0.z); //Richtungsvektor P0-P1
        var vec_p1_2=moi.vectorMath.createPoint(p2.x-p1.x,p2.y-p1.y,p2.z-p1.z); //Richtungsvektor P1-P2
        var n_vec=cross_product(vec_p0_1,vec_p1_2); 	//Normalenvektor der Ebene P0,P1,P2 und Richtungsvektor des Schnitts
        var pPlane_1=add_vector(scale_vector(vec_p0_1,0.5),p0); 	//Punkt des ersten Ebene
	var pPlane_2=add_vector(scale_vector(vec_p1_2,0.5),p1);
        var n0_vec=moi.vectorMath.createPoint();
         var betrag=magnitude(n_vec);
         n0_vec=scale_vector(n_vec,(1/betrag));
            
            var n0_1=scale_vector(vec_p0_1,(1/magnitude(vec_p0_1)));
            var n0_2=scale_vector(vec_p1_2,(1/magnitude(vec_p1_2)));
            var d_1=scalar_product(n0_1,pPlane_1);
            var d_2=scalar_product(n0_2,pPlane_2);
	    var d_3=scalar_product(n0_vec,p1);	
*/
/////////////////////////////////////////////////////////
/*	var a11=n0_1.x;
	var a12=n0_1.y;
	var a13=n0_1.z;
	var a21=n0_2.x;
	var a22=n0_2.y;
	var a23=n0_2.z;
	var a31=n0_vec.x;
	var a32=n0_vec.y;
	var a33=n0_vec.z;
	var DetA=a11*a22*a33 + a12*a23*a31 + a13*a21*a32 - a13*a22*a31 - a12*a21*a33 - a11*a23*a32;
	var DetX=d_1*a22*a33 + a12*a23*d_3 + a13*d_2*a32 - a13*a22*d_3 - a12*d_2*a33 - d_1*a23*a32;
	var DetY=a11*d_2*a33 + d_1*a23*a31 + a13*a21*d_3 - a13*d_2*a31 - d_1*a21*a33 - a11*a23*d_3;
	var DetZ=a11*a22*d_3 + a12*d_2*a31 + d_1*a21*a32 - d_1*a22*a31 - a12*a21*d_3 - a11*d_2*a32; */
	/////////
/*	var DetA=n0_1.x*n0_2.y*n0_vec.z + n0_1.y*n0_2.z*n0_vec.x + n0_1.z*n0_2.x*n0_vec.y - n0_1.z*n0_2.y*n0_vec.x - n0_1.y*n0_2.x*n0_vec.z - n0_1.x*n0_2.z*n0_vec.y;
	var DetX=d_1*n0_2.y*n0_vec.z + n0_1.y*n0_2.z*d_3 + n0_1.z*d_2*n0_vec.y - n0_1.z*n0_2.y*d_3 - n0_1.y*d_2*n0_vec.z - d_1*n0_2.z*n0_vec.y;
	var DetY=n0_1.x*d_2*n0_vec.z + d_1*n0_2.z*n0_vec.x + n0_1.z*n0_2.x*d_3 - n0_1.z*d_2*n0_vec.x - d_1*n0_2.x*n0_vec.z - n0_1.x*n0_2.z*d_3;
	var DetZ=n0_1.x*n0_2.y*d_3 + n0_1.y*d_2*n0_vec.x + d_1*n0_2.x*n0_vec.y - d_1*n0_2.y*n0_vec.x - n0_1.y*n0_2.x*d_3 - n0_1.x*d_2*n0_vec.y; 
*/
	var DetA=vec_p0_1.x*vec_p1_2.y*n_vec.z + vec_p0_1.y*vec_p1_2.z*n_vec.x + vec_p0_1.z*vec_p1_2.x*n_vec.y - vec_p0_1.z*vec_p1_2.y*n_vec.x - vec_p0_1.y*vec_p1_2.x*n_vec.z - vec_p0_1.x*vec_p1_2.z*n_vec.y;
	var DetX=d_1*vec_p1_2.y*n_vec.z + vec_p0_1.y*vec_p1_2.z*d_3 + vec_p0_1.z*d_2*n_vec.y - vec_p0_1.z*vec_p1_2.y*d_3 - vec_p0_1.y*d_2*n_vec.z - d_1*vec_p1_2.z*n_vec.y;
	var DetY=vec_p0_1.x*d_2*n_vec.z + d_1*vec_p1_2.z*n_vec.x + vec_p0_1.z*vec_p1_2.x*d_3 - vec_p0_1.z*d_2*n_vec.x - d_1*vec_p1_2.x*n_vec.z - vec_p0_1.x*vec_p1_2.z*d_3;
	var DetZ=vec_p0_1.x*vec_p1_2.y*d_3 + vec_p0_1.y*d_2*n_vec.x + d_1*vec_p1_2.x*n_vec.y - d_1*vec_p1_2.y*n_vec.x - vec_p0_1.y*vec_p1_2.x*d_3 - vec_p0_1.x*d_2*n_vec.y; 
	if(DetA!=0)
	{
	sp.x=DetX/DetA;
	sp.y=DetY/DetA;
	sp.z=DetZ/DetA;
	} else {
	sp.x=p1.x;
	sp.y=p1.y;
	sp.z=p1.z;
	}
 return sp;
}


function Update( Curve , acFactory , lFactories, plFactory,NumItems, analyse_as, scalefactor ) //wird benutzt, um die Kurve, bei eingabe neuer Werte ins UI, neuzuzeichnen!
{	var plpoints=new Array();
	plpoints.length=0;
	
	for ( var n = 0; n <lFactories.length; ++n )
	{
			lFactories[n].cancel();
			
	}
	lFactories.length=0;
	
		var crv=Curve.item(0);
		var pointfactory = moi.command.createFactory( 'point' ); //Pointfactory erzeugen
		var startPt = crv.getStartPt(); //Anfangspunkt der Kurve erzeugen
		// create point object to array
		pointfactory.setInput( 0, startPt );
		var startPtObject = pointfactory.calculate();
		

//		var acFactory = moi.command.createFactory( 'arraycurve' ); //arraycurve erzeugt ein array entlang einer Kurve - Eingabe ist in der naechsten ZEile der Startpunkt der Kurve
		acFactory.setInput( 0, startPtObject );	// object (list)
		acFactory.setInput( 1, crv );		// path
		acFactory.setInput( 2, 'NumItems' );		// array mode
		acFactory.setInput( 3, NumItems );                     /////////////////////////////////////////////////////////////////////7

		var arrayed_pts = acFactory.calculate();
                var pts = new Array();
		var ptx = new Array();
		pts.push( startPtObject.item(0).pt );
		ptx.push( startPtObject.item(0).pt );
		for ( var iPts = 0; iPts < arrayed_pts.length; ++iPts )
			{ 
			pts.push( arrayed_pts.item(iPts).pt );
			ptx.push( arrayed_pts.item(iPts).pt );
                        }
		
 //               var cp =moi.vectorMath.createPoint(); 
 // 			var pt=new Array();              

		var cp=moi.vectorMath.createPoint();
		if(analyse_as=='radius')
		{
			for ( var n = 0; n < ptx.length-2; ++n )
			{
			lFactory=moi.command.createFactory( 'line' );
			cp=csp(ptx[n],ptx[n+1],ptx[n+2]);
				//cp=csp(ptx[n].x,ptx[n].y,ptx[n].z,ptx[n+1].x,ptx[n+1].y,ptx[n+1].z,ptx[n+2].x,ptx[n+2].y,ptx[n+2].z);
			var d_vec=moi.vectorMath.createPoint(cp.x-ptx[n+1].x,cp.y-ptx[n+1].y,cp.z-ptx[n+1].z);
////#######################################################
				var magnr=magnitude(d_vec);
				if(magnr<10000)     //###################################
				{
				var sd_vec=moi.vectorMath.createPoint(d_vec.x*scalefactor,d_vec.y*scalefactor,d_vec.z*scalefactor);
				var scp=moi.vectorMath.createPoint(sd_vec.x+ptx[n+1].x,sd_vec.y+ptx[n+1].y,sd_vec.z+ptx[n+1].z);
				lFactory.setInput(0,ptx[n+1]);         
			        lFactory.setInput(1,scp);
			        lFactories.push(lFactory);
				}else{scp=moi.vectorMath.createPoint(ptx[n+1].x,ptx[n+1].y,ptx[n+1].z);
				}
			
				if(scalefactor!=1)
				plpoints.push(scp);
			}
		}else{
			for ( var n = 0; n < ptx.length-2; ++n )
			{
			lFactory=moi.command.createFactory( 'line' );
			cp=csp(ptx[n],ptx[n+1],ptx[n+2]);
				//cp=csp(ptx[n].x,ptx[n].y,ptx[n].z,ptx[n+1].x,ptx[n+1].y,ptx[n+1].z,ptx[n+2].x,ptx[n+2].y,ptx[n+2].z);
			var d_vec=moi.vectorMath.createPoint(ptx[n+1].x-cp.x,ptx[n+1].y-cp.y,ptx[n+1].z-cp.z);
				var magn=magnitude(d_vec);
				var sf=scalefactor*1000.0;
			if(magn>0.002){                                       //#################################
			var sd_vec=moi.vectorMath.createPoint((d_vec.x*sf/(magn*magn)),(d_vec.y*sf/(magn*magn)),(d_vec.z*sf/(magn*magn)));
			var scp=moi.vectorMath.createPoint(sd_vec.x+ptx[n+1].x,sd_vec.y+ptx[n+1].y,sd_vec.z+ptx[n+1].z);
			lFactory.setInput(0,ptx[n+1]);
			lFactory.setInput(1,scp);
			lFactories.push(lFactory);
			}else
				{scp=moi.vectorMath.createPoint(ptx[n+1].x,ptx[n+1].y,ptx[n+1].z);
				}
//###########################################
			plpoints.push(scp);

			}
		}
	
		
		acFactory.update();
		for ( var n = 0; n <  lFactories.length; ++n ) //#############################
		lFactories[n].update();

		
		plFactory.createInput('point');
		for ( var n = 0; n < plpoints.length; ++n )
		{	plFactory.createInput('point');
			plFactory.setInput(n,plpoints[n]);	
			//plFactory.calculate();
		}
		plFactory.update();
}

function commit(acFactory, lFactories,plFactory)
{acFactory.commit();
	for ( var n = 0; n < lFactories.length; ++n )
		lFactories[n].commit();
	plFactory.commit();
}


function CCC()
{
	var ObjectPicker = moi.ui.createObjectPicker();
	ObjectPicker.max=1;
	ObjectPicker.allowStandaloneCurves(); //nur Kurven selektieren

	if ( !GetObjects( ObjectPicker ) )
	return;

	var Curve = ObjectPicker.objects; //Speichert die selektierten Kurven im Objekt Curves

//	Curve.setProperty( 'locked', true );

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectPrompt' );
	moi.ui.hideUI( 'AnalysisOptions' );
	moi.ui.showUI( 'ReconstructPrompt' );
	moi.ui.showUI( 'ReconstructPtOptions' );
	moi.ui.endUIUpdate();
	var fact = moi.ui.commandUI.analyse_as.value; //in fact steht die art der Rekonstruktion polyline, durch kontrollpunkte usw.

 //               Factory = moi.command.createFactory( 'polyline' ); //setzen der Factory auf die Kurvenart Poly
//		Factory.createInput( 'point' );
//		Factory.setInput( 0, startPt );
var acfactory=moi.command.createFactory( 'arraycurve' );
var lfactories=new Array();
//var plfactory=moi.command.createFactory( 'polyline' );
var plfactory=moi.command.createFactory( 'interpcurve' );
//		Factories[i][2] = originalCrv.isClosed;

        

//	pointfactory.cancel();

	// Get the values from the UI controls.
	var NumItems = moi.ui.commandUI.NumItems.integerValue;
	var analyse_as=moi.ui.commandUI.analyse_as.value;
	var scalefactor=moi.ui.commandUI.scalefactor.numericValue;
	//var scalefactor=0.1;
	// Show the initial result.
	Update( Curve,acfactory, lfactories,plfactory, NumItems, analyse_as, scalefactor );

	// Wait for cancel or done.
	var dialog = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dialog.waitForEvent() )
		{
			Curve.setProperty( 'locked', false );
			return; // Canceled.
		}

		if ( dialog.event == 'done' )
			break;

		if ( dialog.event == 'NumItems' || dialog.event == 'analyse_as' || dialog.event == 'scalefactor' )
		{
			// NumItems control changed
			NumItems = moi.ui.commandUI.NumItems.integerValue;
			analyse_as=moi.ui.commandUI.analyse_as.value;
			scalefactor=moi.ui.commandUI.scalefactor.numericValue;
			Update( Curve,acfactory, lfactories,plfactory, NumItems,analyse_as,scalefactor );
		}
	}

commit(acfactory, lfactories, plfactory);	

}

CCC();
