// config: norepeat

#include "GetObjects.js"

function magnitude(vec)
{
	var mag;
	mag=Math.sqrt(vec.x*vec.x+vec.y*vec.y+vec.z*vec.z);
return mag;
}

function Update_ptxfactories( ptx )
{
	var ptxfactories = new Array();	
	for ( var i = 0; i < ptx.length; ++i )
	{
		var ptxfactory = moi.command.createFactory( 'point' );
		ptxfactory.setInput( 0, ptx[i] );
		ptxfactories.push( ptxfactory );
	}
	for ( var i = 0; i < ptxfactories.length; ++i )
		ptxfactories[i].update();
	return ptxfactories;	
}
	
function Update_lFactories( ptx, lFactories, plFactory, NumItems, analyse_as, scalefactor )
{	
	var plpoints=new Array();
//	plpoints.length=0;

	for ( var n = 0; n < lFactories.length; ++n )
	{
			lFactories[n].cancel();
	}
//	lFactories.length=0;

		var cp = moi.vectorMath.createPoint();
		if(analyse_as=='radius')
		{
			for ( var n = 0; n < ptx.length-2; ++n )
			{
			lFactory=moi.command.createFactory( 'line' );
//			cp=csp(ptx[n],ptx[n+1],ptx[n+2]);
			cp = moi.ui.commandUI.csp(ptx[n],ptx[n+1],ptx[n+2]); //htm version			
				//cp=csp(ptx[n].x,ptx[n].y,ptx[n].z,ptx[n+1].x,ptx[n+1].y,ptx[n+1].z,ptx[n+2].x,ptx[n+2].y,ptx[n+2].z);
			var d_vec=moi.vectorMath.createPoint(cp.x-ptx[n+1].x,cp.y-ptx[n+1].y,cp.z-ptx[n+1].z);
////#######################################################
				var magnr=magnitude(d_vec);
				if(magnr<10000)     //###################################
				{
				var sd_vec=moi.vectorMath.createPoint(d_vec.x*scalefactor,d_vec.y*scalefactor,d_vec.z*scalefactor);
				var scp=moi.vectorMath.createPoint(sd_vec.x+ptx[n+1].x,sd_vec.y+ptx[n+1].y,sd_vec.z+ptx[n+1].z);
				lFactory.setInput(0,ptx[n+1]);         
			        lFactory.setInput(1,scp);
			        lFactories.push(lFactory);
				}else{scp=moi.vectorMath.createPoint(ptx[n+1].x,ptx[n+1].y,ptx[n+1].z);
				}
			
				if(scalefactor!=1)
				plpoints.push(scp);
			}
		}else{
			for ( var n = 0; n < ptx.length-2; ++n )
			{
			lFactory=moi.command.createFactory( 'line' );
//			cp=csp(ptx[n],ptx[n+1],ptx[n+2]);
			cp = moi.ui.commandUI.csp(ptx[n],ptx[n+1],ptx[n+2]); //htm version	//<<<<<<		
				//cp=csp(ptx[n].x,ptx[n].y,ptx[n].z,ptx[n+1].x,ptx[n+1].y,ptx[n+1].z,ptx[n+2].x,ptx[n+2].y,ptx[n+2].z);
			var d_vec=moi.vectorMath.createPoint(ptx[n+1].x-cp.x,ptx[n+1].y-cp.y,ptx[n+1].z-cp.z);
				var magn=magnitude(d_vec);
				var sf=scalefactor*1000.0;
			if(magn>0.002){                                       //#################################
			var sd_vec=moi.vectorMath.createPoint((d_vec.x*sf/(magn*magn)),(d_vec.y*sf/(magn*magn)),(d_vec.z*sf/(magn*magn)));
			var scp=moi.vectorMath.createPoint(sd_vec.x+ptx[n+1].x,sd_vec.y+ptx[n+1].y,sd_vec.z+ptx[n+1].z);
			lFactory.setInput(0,ptx[n+1]);
			lFactory.setInput(1,scp);
			lFactories.push(lFactory);
			}else
				{scp=moi.vectorMath.createPoint(ptx[n+1].x,ptx[n+1].y,ptx[n+1].z);
				}
//###########################################
			plpoints.push(scp);

			}
		}
	
		for ( var n = 0; n <  lFactories.length; ++n ) //#############################
		lFactories[n].update();
		
		plFactory.createInput('point');
		for ( var n = 0; n < plpoints.length; ++n )
		{	plFactory.createInput('point');
			plFactory.setInput(n,plpoints[n]);	
			//plFactory.calculate();
		}
		plFactory.update();
		
}

/*
function commit(acFactory, lFactories, plFactory)
{
	acFactory.commit();
	for ( var n = 0; n < lFactories.length; ++n )
		lFactories[n].commit();
	plFactory.commit();
}
*/

function Commit( factories )
{
	for ( var i = 0; i < factories.length; ++i )
		factories[i].commit();
}

function CCC()
{
	var UI = moi.ui.commandUI;
	var ObjectPicker = moi.ui.createObjectPicker();
	ObjectPicker.max=1;
	ObjectPicker.allowStandaloneCurves(); //nur Kurven selektieren

	if ( !GetObjects( ObjectPicker ) )
	return;

	var Curve = ObjectPicker.objects; //Speichert die selektierten Kurven im Objekt Curves

//	Curve.setProperty( 'locked', true );

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectPrompt' );
	moi.ui.hideUI( 'AnalysisOptions' );
	moi.ui.showUI( 'ReconstructPrompt' );
	moi.ui.showUI( 'ReconstructPtOptions' );
	moi.ui.endUIUpdate();
	var fact = moi.ui.commandUI.analyse_as.value; //in fact steht die art der Rekonstruktion polyline, durch kontrollpunkte usw.

 //               Factory = moi.command.createFactory( 'polyline' ); //setzen der Factory auf die Kurvenart Poly
//		Factory.createInput( 'point' );
//		Factory.setInput( 0, startPt );
//var acfactory=moi.command.createFactory( 'arraycurve' );

var lFactories = new Array();
//var plFactory=moi.command.createFactory( 'polyline' );
var plFactory=moi.command.createFactory( 'interpcurve' );
//		Factories[i][2] = originalCrv.isClosed;

//	pointfactory.cancel();

	// Get the values from the UI controls.

//	var NumItems = moi.ui.commandUI.NumItems.integerValue;
//	var analyse_as=moi.ui.commandUI.analyse_as.value;
//	var scalefactor=moi.ui.commandUI.scalefactor.numericValue;
	//var scalefactor=0.1;
	// Show the initial result.

	// Create the arrayed points with function getacpoints in htm.
	var ptx = new Array();
	var ptxfactories = new Array();
	ptx = moi.ui.commandUI.getacpoints( Curve, UI.NumItems.integerValue );  //htm version	
	ptxfactories = Update_ptxfactories( ptx );	
	Update_lFactories( ptx, lFactories, plFactory, UI.NumItems.integerValue, UI.analyse_as.value, UI.scalefactor.numericValue );

	// Wait for cancel or done.
	var dialog = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dialog.waitForEvent() )
		{
			Curve.setProperty( 'locked', false );
			return; // Canceled.
		}

		if ( dialog.event == 'done' )
			break;

		if ( dialog.event == 'NumItems' || dialog.event == 'analyse_as' || dialog.event == 'scalefactor' )
		{
			// NumItems control changed
//			NumItems = moi.ui.commandUI.NumItems.integerValue;
//			analyse_as=moi.ui.commandUI.analyse_as.value;
//			scalefactor=moi.ui.commandUI.scalefactor.numericValue;

			ptx = moi.ui.commandUI.getacpoints( Curve, UI.NumItems.integerValue );  //htm version	
			ptxfactories = Update_ptxfactories( ptx );
			Update_lFactories( ptx, lFactories, plFactory, UI.NumItems.integerValue, UI.analyse_as.value, UI.scalefactor.numericValue );
			}
	}

//commit(acfactory, lFactories, plFactory);
	Commit( ptxfactories );
	Commit( lFactories );
	plFactory.commit();

}

CCC();
