#include "GetObjects.js"

function DoCloseCurve()
{
	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.allowCurves();
	if ( !GetObjects( objectpicker ) )
		return;

	var curves = objectpicker.objects;
	for ( var i = 0; i < curves.length; ++i )
	{
		var crv = curves.item(i);
		if ( crv.isClosed )
			continue;
			
		// Create a line segment between the ends of this open curve.
		var linefactory = moi.command.createFactory( 'line' );
		linefactory.setInput( 0, crv.getStartPt() );
		linefactory.setInput( 1, crv.getEndPt() );
		var output = linefactory.calculate(); // Calculate returns an object list.
		if ( output.length != 1 )
			continue;
			
		var line = output.item(0);
		moi.geometryDatabase.addObject( line );

		// Join the line and the curve together.
		var objectstojoin = moi.geometryDatabase.createObjectList();
		objectstojoin.addObject( line );
		objectstojoin.addObject( crv );
		
		var joinfactory = moi.command.createFactory( 'join' );
		joinfactory.setInput( 0, objectstojoin );
		joinfactory.commit();
	}
}

DoCloseCurve();
