#include "GetPointOsnappedOnCurve.js"

var g_Factory = null;

function GetGsnap( pickedpt )
{
	for ( var i = 0; i < pickedpt.numOsnaps; ++i )
	{
		if ( pickedpt.osnap(i).isOnCurve )
			return pickedpt.osnap(i);
	}

	return null;
}

function DoUpdate( pointpicker )
{
	if ( g_Factory )
	{
		g_Factory.cancel();
		g_Factory = null;
	}

	var osnap = GetGsnap( pointpicker.pt );
	if ( !osnap )
		return;

	var t = osnap.parameter;
	var crv = osnap.object;

	var pt = crv.evaluatePoint( t );
	var tangent = crv.evaluateTangent( t );
	var curvature = crv.evaluateCurvature( t );

	var magsq = (curvature.x * curvature.x) + (curvature.y * curvature.y) + (curvature.z * curvature.z);
	if ( magsq > 0.000001 )
	{
		var mag = Math.sqrt(magsq);

		var radius = 1.0 / mag;
		curvature.scale( radius );

		pt.x += curvature.x * radius;
		pt.y += curvature.y * radius;
		pt.z += curvature.z * radius;

		var frame = moi.vectorMath.createFrame( pt, tangent, curvature );
		
		g_Factory = moi.command.createFactory( 'circle' );
		g_Factory.setInput( 0, true ); // "Is Radius"
		g_Factory.setInput( 1, frame );
		g_Factory.setInput( 3, radius );
		g_Factory.update();
	}
}

function DoCurvatureCircle()
{
	var ui = moi.ui;
	var pointpicker = ui.createPointPicker();
	pointpicker.enableOnObjectSnap = true;

	pointpicker.bindFuncPostUpdate( DoUpdate );
	if ( !GetPointOsnappedOnCurve( pointpicker ) )
		return;
	
	if ( g_Factory )
		g_Factory.commit();
}

DoCurvatureCircle();
