// config: norepeat

#include "GetObjects.js"

function ExportCentered()
{
	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.allowTopLevelObjects();
	if ( !GetObjects( objectpicker ) )
		return;
		
	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectObjectsPrompt' );
	moi.ui.hideUI( 'done' );
	moi.ui.hideUI( 'cancel' );
	moi.ui.showUI( 'FileNamePrompt' );
	moi.ui.endUIUpdate();

	// Move each object separately from it's bounding box center to the cplane origin.
	
	var input_objects = objectpicker.objects;
	var moved_objects = moi.geometryDatabase.createObjectList();
	
	for ( var i = 0; i < input_objects.length; ++i )
	{
		var this_obj = input_objects.item(i);
		var this_list = moi.geometryDatabase.createObjectList();
		this_list.addObject( this_obj );
	
		var factory = moi.command.createFactory( 'copy' );
		factory.setInput( 0, this_list );
		factory.setInput( 1, this_list.getHighAccuracyBoundingBox().center );
		factory.setInput( 2, moi.view.getCPlane().origin );
		
		factory.update();
		
		var this_moved_objects = factory.getCreatedObjects();
		for ( var j = 0; j < this_moved_objects.length; ++j )
			moved_objects.addObject( this_moved_objects.item(j) );
			
		factory.commit();
	}
	
	// Select the moved objects, export them, then remove the moved objects.
	
	input_objects.unlockSelection();
	moved_objects.unlockSelection();
	moi.geometryDatabase.deselectAll();
	moved_objects.setProperty( 'selected', true );
	
	moi.geometryDatabase.fileExport( moi.command.getCommandLineParams() );
	
	moi.geometryDatabase.removeObjects( moved_objects );
}

ExportCentered();
