// Draw Hilbert Curve using recursion.
// Brian McMillin January 16, 2014

/* x0 and y0 are the coordinates of the lower left hand corner.
   i and j are used to reduce confusion with x and y.
   i corresponds to a unit vector along the x axis.
   j corresponds to a unit vector along the y axis.
   xi and xj are the i & j components of the x vector. (~Point X) 
   yi and yj are the i & j components of the y vector. (~Point Y)
   This is explained more in the references:
   http://fundza.com/algorithmic/space_filling/hilbert/basics/index.html
   http://www.donrelyea.com/hilbert_algorithmic_art_menu.htm
   num or "n" is the degree of the Hilbert curve, and should be less than about 7 +/-.
   The two values of 300 needed to be swapped from xi to xj and yj to yi, to get matching results.
 */

function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function DoHilbertKoch()
{
	moi.ui.commandUI.Update();

	// Wait for cancel or done.
	var dlg = moi.ui.commandDialog;

	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			moi.ui.commandUI.Cancel();
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'x0' || dlg.event == 'y0' || dlg.event == 'xi' || dlg.event == 'xj' || dlg.event == 'yi' || dlg.event == 'yj' || dlg.event == 'num' || dlg.event == 'Build' )
			moi.ui.commandUI.Update();
	}
}

DoHilbertKoch();
