#include "GetObjects.js"
#include "WaitForDialogDone.js"

function MakePointLabel( ptobj )
{
	var text = '(';
	text += moi.ui.formatCoordinate(ptobj.pt.x);
	text += ',';
	text += moi.ui.formatCoordinate(ptobj.pt.y);
	text += ')';

	var ptframe = moi.vectorMath.createTopFrame();
	ptframe.origin = ptobj.pt;

	var factory = moi.command.createFactory( 'annotationtext' );
	factory.setInput( 0, ptframe );
	factory.setInput( 1, text );
	factory.setInput( 2, moi.ui.commandUI.AnnotationPreset.value );

	factory.update();
	factory.commit();
}

function DoLabelPointCoordinates()
{
	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.allowPointObjects();
	if ( !GetObjects( objectpicker ) )
		return;
		
	var pts = objectpicker.objects.getPoints();

	moi.ui.beginUIUpdate();
	moi.ui.hideUI( 'SelectPrompt' );
	moi.ui.showUI( 'OptionsPrompt' );
	moi.ui.showUI( 'Options' );
	moi.ui.endUIUpdate();

	if ( !WaitForDialogDone() )
		return;

	for ( var i = 0; i < pts.length; ++i )
		MakePointLabel( pts.item(i) );
}

DoLabelPointCoordinates();
