
function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function Update()
{
	var factory = moi.command.createFactory( 'curve' );

	var aValue = moi.ui.commandUI.aValue.numericValue;
	var bValue = moi.ui.commandUI.bValue.numericValue;
	var cValue = moi.ui.commandUI.cValue.numericValue;	
	var h = moi.ui.commandUI.h.numericValue;
	var numpoints = moi.ui.commandUI.numpoints.integerValue;
	var x0 = 0.1;
	var y0 = 0.0;
	var z0 = 0.0;

	var pt = moi.vectorMath.createPoint( x0, y0, z0 );
	factory.createInput( 'point' );
	factory.setInput( factory.numInputs - 1, pt );
	
	for ( var i = 0; i < numpoints; ++i )
	{
		x1 = x0 + h*aValue*(y0 - x0);
		y1 = y0 + h*(x0*(bValue-z0) - y0);
		z1 = z0 + h*(x0 * y0 - cValue * z0);
		x0 = x1;
		y0 = y1;
		z0 = z1;
	
		var pt = moi.vectorMath.createPoint( x0, y0, z0 );		
		
		factory.createInput( 'point' );
		factory.setInput( factory.numInputs - 1, pt );
	}
	
	factory.update();
	
	return factory;
}

function DoLorenz()
{
	var factory = Update();

	var dlg = moi.ui.commandDialog;
	
	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			factory.cancel();
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'aValue' || dlg.event == 'bValue' || dlg.event == 'cValue' ||  dlg.event == 'h' || dlg.event == 'numpoints' )
		{
			factory.cancel();
			factory = Update();
		}
	}
	
	factory.commit();
}

DoLorenz();
