// PointCoordinates is a simple script which displays an alert message with
// the X, Y, and Z coordinates of a picked point.
// It is a modification of point.js and point.htm script.
// Pushing Cancel before selecting point, will leave ObjectSnap button on and Pt snap on.
// The coordinates are also copied to the clipboard as (x, y, z).

#include "GetPoint.js"

function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}
// Help from Michael, Burr, and Umdee:
// http://moi3d.com/forum/index.php?webtag=MOI&msg=7457.11
// http://moi3d.com/forum/index.php?webtag=MOI&msg=7056.2
// http://moi3d.com/forum/index.php?webtag=MOI&msg=7323.4

function DoPoint()
{
	var drawingAids = moi.drawingAids;
	var objSnapPt = drawingAids.objectSnapPt; // Save Point snap state.
	drawingAids.objectSnapPt = true; // Turn on point snap.
	var objectSnapButton = drawingAids.objectSnap; // Save button state.
	drawingAids.objectSnap = true; // Enable ObjectSnap button.
	
	var pointPicker = moi.ui.createPointPicker();
	// pointPicker.enableObjectSnap = true; // Does not work.

	if ( !GetPoint( pointPicker ) ) return;
	
	var pt = pointPicker.pt;

	drawingAids.objectSnapPt = objSnapPt; // Restore Point snap state.
	drawingAids.objectSnap = objectSnapButton; // Restore button state.

	var str = '';
	//var str = '('; // add a beginning (
	
	function AddNumber( num )
	{
		// Use 6 decimal places.  parseFloat removes trailing zero's.
			str = str + parseFloat(num.toFixed(6));
	}

	function AddCoordinate( pt )
	{
		str = "( ";
		AddNumber( pt.x, str );
		str = str + ", ";
		AddNumber( pt.y, str );
		str = str + ", ";
		AddNumber( pt.z, str );
		str = str + " )";
		//str = str + ")\r\n"; // add an ending  cr lf )
	}

	AddCoordinate( pt );
	moi.copyTextToClipboard(str);	
	
	// Round to 6 decimal digits and display as alert.
	var Xval = parseFloat(pt.x.toFixed(6));
	var Yval = parseFloat(pt.y.toFixed(6));
	var Zval = parseFloat(pt.z.toFixed(6));	
	//var Xval = pt.x.toFixed(6);
	//var Yval = pt.y.toFixed(6);
	//var Zval = pt.z.toFixed(6);

	alert( 'X = ' + Xval + '    Y = ' + Yval + '    Z = ' + Zval)
	
	moi.ui.clearPickedPoints();	
}

DoPoint();
