// PointsToCurves v.1.0 - Max Smirnov. 2013
function PlacePoints(curve, distance)
{
	var pt, factory, num;
	var points = moi.GeometryDatabase.createObjectList();
	var crv = moi.GeometryDatabase.createObjectList();
	crv.addObject(curve);
	factory = moi.command.createFactory( 'separate' );
	factory.setInput( 0, crv );
	factory.commit();
	var subcurves = moi.geometryDatabase.getSelectedObjects().getCurves();
	if ( subcurves.length === 0 )  subcurves = crv;
	for (var f=0;  f < subcurves.length; ++f)
	{
		factory = moi.command.createFactory( 'point' );
		factory.setInput(0, subcurves.item(f).getStartPt());
		pt = factory.calculate();
		points.addObject(pt.item(0));
		num = Math.ceil(subcurves.item(f).GetLength()/distance)+1;
		
		factory = moi.command.createFactory( 'arraycurve' );
		factory.setInput( 0, pt );
		factory.setInput( 1, subcurves.item(f) );
		factory.setInput( 2, 'NumItems' );
		factory.setInput( 3,  num);
		factory.setInput( 5, 'None' );
		pt = factory.calculate();
		for (var p=0;  p < pt.length-1; ++p)  points.addObject(pt.item(p));
	}
	if ( !curve.isClosed || (curve.isClosed && subcurves.length === 1) )  points.addObject(pt.item(p));
	factory = moi.command.createFactory( 'join' );
	factory.setInput( 0, subcurves);
	factory.commit();
	return points;
}

function PointsOnCurve()
{
	var curves = moi.geometryDatabase.getSelectedObjects().getCurves();	
	if ( curves.length > 0 )
	{
		while ( 1 )
		{
			if ( !moi.ui.commandDialog.waitForEvent() )
				return;
				
			if ( moi.ui.commandDialog.event == 'done' )
				break;
		}
		var dist = moi.ui.commandUI['PointDist'].value; 
		curves.setProperty( 'selected', false);
		for (var s=0;  s < curves.length; ++s)
		{
			var pts = PlacePoints(curves.item(s), dist);
			moi.GeometryDatabase.addObjects (pts);
		}
	}
}

PointsOnCurve();

