#include "GetObjects.js"

function DoBisectorLine()
{
	moi.geometryDatabase.deselectAll();

	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.allowCurves();
	objectpicker.min = objectpicker.max = 2;

	if ( !GetObjects( objectpicker ) )
		return;
		
	var lines = objectpicker.objects;
	if ( lines.length != 2 )
		return;
		
	var A = lines.item(0).getStartPt();
	var B = lines.item(0).getEndPt();
	var C = lines.item(1).getStartPt();
	var D = lines.item(1).getEndPt();
	
	var vm = moi.vectorMath;
	
	var E, F;
	
	if ( vm.distance(A,C) + vm.distance(B,D) < vm.distance(A,D) + vm.distance(B,C) )
	{
		E = vm.average(A,C);
		F = vm.average(B,D);
	}
	else
	{
		E = vm.average(A,D);
		F = vm.average(B,C);	
	}

	var linefactory = moi.command.createFactory( 'line' );
	linefactory.setInput( 0, E );
	linefactory.setInput( 1, F );
	linefactory.commit();
	
	lines.setProperty( 'selected', false );
}

DoBisectorLine();
