// config: norepeat noautolaunch

#include "GetObjects.js"

function DoRotateObjects()
{
	// Wait for rotation angle to be entered - either a new value entered into the
	// field, or the "Done" button pushed to accept the default value.
	
	var commandDialog = moi.ui.commandDialog;
	
	while ( 1 )
	{
		if ( !commandDialog.waitForEvent() )
			return false; // Command was canceled.
			
		if ( commandDialog.event == 'done' || commandDialog.event == 'angle' )
			break; // Done was pushed or a new angle value entered.
	}
	
	var angle = moi.ui.commandUI.angle.numericValue;
	

	var objectpicker = moi.ui.createObjectPicker();
	if ( !GetObjects( objectpicker ) )
		return;
		
	// Coordinate frame for rotation.
	var frame = moi.vectorMath.createTopFrame();
	
	switch( moi.ui.commandUI.plane.value )
	{
	case 'front': frame = moi.vectorMath.createFrontFrame(); break;
	case 'right': frame = moi.vectorMath.createRightFrame(); break;
	}

		
	var objs = objectpicker.objects;
		
	// Set up a rotation of each object around its own centroid point.
	for ( var i = 0; i < objs.length; ++i )
	{
		var obj = objs.item(i);
		
		var objlist = moi.geometryDatabase.createObjectList();
		objlist.addObject( obj );
		
		// Objects to rotate.		
		var factory = moi.command.createFactory( 'rotate' );
		factory.setInput( 0, objlist );
		
		frame.origin = obj.getBoundingBox(true).center;
		factory.setInput( 1, frame );
		
		// Angle to rotate by.
		factory.setInput( 2, angle );
		
		factory.commit();
	}
}

DoRotateObjects();
