// config: norepeat

function DoSaveMultiSTL()
{
	var MeshAngle = 5.0;

	var basename = moi.filesystem.getSaveFileName( 'Choose base file name', 'STL files (*.stl)|*.stl' );
	if ( basename == '' )
		return;
	
	// Strip off the .stl part of the filename.	
	basename = basename.substr( 0, basename.lastIndexOf('.') );
	
	var objects = moi.geometryDatabase.getObjects();
	objects.setProperty( 'selected', false );

	var options = 'NoUI=true;Angle=' + MeshAngle.toString();

	var counter = 0;
	
	for ( var i = 0; i < objects.length; ++i )
	{
		var obj = objects.item(i);
		if ( obj.hidden || obj.isCurve )
			continue;
			
		++counter;	
		var thisname = basename + counter.toString() + '.stl';

		obj.selected = true;
		
		moi.geometryDatabase.fileExport( thisname, options );

		obj.selected = false;	
	}
}

DoSaveMultiSTL();
