//	The Sears-Haack body is an aerodynamic body with low drag.  (See Wikipedia)
//	The script forms the curve, which can then be revolved.
//	By Brian McMillin, February 24, 2013, in response to ogives question.
//	(This is a quick modification of sinewave script.)

function alert( msg )
{
	moi.ui.commandUI.alert( msg );
}

function EvalSearsHaack( t, radiusmax, len )
{
	var x = radiusmax * Math.pow(4 * t * (1 - t) , 0.75 );
	var y =  t * len;
	var z = 0.0;	
	return moi.vectorMath.createPoint( x, y, z );
}

function Update()
{
	var factory = moi.command.createFactory( 'curve' );

	var radiusmax = moi.ui.commandUI.radiusmax.numericValue;
	var len = moi.ui.commandUI.len.numericValue;
	var numpoints = moi.ui.commandUI.numpoints.integerValue;
	
	for ( var i = 0; i <= numpoints; ++i )
	{
		var t = i / numpoints ;
		
		var pt = EvalSearsHaack( t, radiusmax, len );		
		
		factory.createInput( 'point' );
		factory.setInput( factory.numInputs - 1, pt );
	}
	
	factory.update();
	
	return factory;
}

function DoSearsHaackCurve()
{
	var factory = Update();

	var dlg = moi.ui.commandDialog;
	
	while ( 1 )
	{
		if ( !dlg.waitForEvent() )
		{
			factory.cancel();
			return false;
		}
			
		if ( dlg.event == 'done' )
			break;
			
		if ( dlg.event == 'radiusmax' || dlg.event == 'len' || dlg.event == 'numpoints' )
		{
			factory.cancel();
			factory = Update();
		}
	}
	
	factory.commit();
}

DoSearsHaackCurve();
