
function Separate( breps )
{
	var separated = moi.geometryDatabase.createObjectList();
	var needs_separation = moi.geometryDatabase.createObjectList();

	// Objects that are already single surfaces don't need to be separated, gather single surfaces and joined
	// surfaces into 2 different object lists.
	
	for ( var i = 0; i < breps.length; ++i )
	{
		var brep = breps.item(i);
		if ( brep.isSingleFaceBRep )
			separated.addObject( brep );
		else
			needs_separation.addObject( brep );
	}
	
	// Run the things that need to be separated through the separate factory.	
	var factory = moi.command.createFactory( 'separate' );
	factory.setInput( 0, needs_separation );
	
	factory.update();
	var result = factory.getCreatedObjects();
	factory.commit();

	
	for ( var i = 0; i < result.length; ++i )
		separated.addObject( result.item(i) );
		
	return separated;	
}

function DoSelectOuterLoopsAndDelete()
{
	var gd = moi.geometryDatabase;

	var breps = gd.getSelectedObjects().getBReps();
	gd.deselectAll();
	
	
	breps = Separate( breps );
	

	var stuff_to_delete = gd.createObjectList();

	for ( var i = 0; i < breps.length; ++i )
	{
		var brep = breps.item(i);
		var faces = brep.getFaces();
		for ( var j = 0; j < faces.length; ++j )
		{
			var face = faces.item(j);
			var loops = face.getLoops();
			var edges = loops.item(0);

			for ( var k = 0; k < edges.length; ++k )
			{
				var edge = edges.item(k);
				if ( edge.getFacesOfEdge().length == 1 )
				{
					stuff_to_delete.addObject( edge );
				}
			}
		}
	}

	var factory = moi.command.createFactory( 'delete' );
	factory.setInput( 0, stuff_to_delete );
	
	factory.update();
	var output = factory.getCreatedObjects();
	factory.commit();
	output.setProperty( 'selected', true );

	
	moi.command.execCommand( 'Trim' );
}


DoSelectOuterLoopsAndDelete();

