// SketchCurve Advanced v.0.9 - Max Smirnov (RUS) 2013

function DoSketchCurve()
{
	var cam, perspective, vp;
	var obj = moi.geometryDatabase.getSelectedObjects().getBReps();
	var pointstreampicker = moi.ui.createPointStreamPicker();
	var sCPlane = moi.view.getCPlane();
	/* moi.view.setCPlane(vp.targetFrame, false); */
	var hlo = moi.view.hiddenLineOpacity;
	var hls = moi.view.hiddenLineStyle;
	var shl = moi.view.showHiddenLines;
	if ( obj.length > 0 ) 	
	{ 
		moi.ui.beginUIUpdate();  
		moi.ui.showUI( 'ScaOptions' ); 
		moi.ui.endUIUpdate(); 
		moi.view.hiddenLineOpacity = 50;
		moi.view.hiddenLineStyle = 'Solid';
		moi.view.showHiddenLines = true;
	}
	var factory = moi.command.createFactory( 'sketchcurve' );
	pointstreampicker.bind( factory );
	while ( 1 )
	{
		if ( !pointstreampicker.waitForEvent() )	{ moi.view.hiddenLineOpacity = hlo; moi.view.showHiddenLines = shl; moi.view.hiddenLineStyle = hls; /* moi.view.setCPlane(sCPlane); */ return; }
			
		if ( pointstreampicker.event == 'finished' ) 
		{ 	
			if (obj.length === 0) { moi.view.hiddenLineOpacity = hlo; moi.view.showHiddenLines = shl; moi.view.hiddenLineStyle = hls; factory.commit(); return; }
			vp = moi.ui.getLastClickedViewport();
			perspective = (vp.name === "3D" && vp.projection === "Perspective");
			
			var scurve = factory.calculate(); 
			if ( scurve.length === 0 ) { break; }

			cam = vp.cameraFrame;

			if ( perspective ) 
			{
				factory = moi.command.createFactory( 'sphere' );
				factory.setInput( 0, true );
				factory.setInput( 1, cam );
				factory.setInput( 3, 10 );
				var camsphere = factory.calculate();
				
				factory = moi.command.createFactory( 'line' );
				factory.setInput( 0, scurve.item(0).getStartPt() );
				factory.setInput( 1, cam.origin );
			} 
			else
			{
				factory = moi.command.createFactory( 'line' );
				factory.setInput( 0, cam.evaluate( cam.distancex( scurve.item(0).getStartPt() ), cam.distancey( scurve.item(0).getStartPt() ) , cam.distancez( scurve.item(0).getStartPt() ) + 0) );
				factory.setInput( 1, cam.evaluate( cam.distancex( scurve.item(0).getStartPt() ), cam.distancey( scurve.item(0).getStartPt() ) , cam.distancez( scurve.item(0).getStartPt() ) + 10) );
			}
			var ray = factory.calculate();					
				
			factory = moi.command.createFactory( 'arraycurve' );
			factory.setInput( 0, ray );
			factory.setInput( 1, scurve.item(0) );
			factory.setInput( 2, 'NumItems' );
			factory.setInput( 3, moi.ui.commandUI['numpoints'].value);
			factory.setInput( 5, 'None' );
			if ( perspective )  { factory.setInput( 7, camsphere.item(0) ); }
			var rays = factory.calculate();
				
			if ( perspective ) 
			{	
				factory = moi.command.createFactory( 'scale' );
				factory.setInput( 0, rays );
				factory.setInput( 1, cam.origin );
				factory.setInput( 2, 0.001 );
				factory.setInput( 5, false );
			}
			else
			{	
				factory = moi.command.createFactory( 'move' );
				factory.setInput( 0, rays );
				factory.setInput( 1, cam.evaluate( cam.distancex( scurve.item(0).getStartPt() ), cam.distancey( scurve.item(0).getStartPt() ) , cam.distancez( scurve.item(0).getStartPt() ) + 0));
				factory.setInput( 2, cam.evaluate( cam.distancex( scurve.item(0).getStartPt() ), cam.distancey( scurve.item(0).getStartPt() ) , cam.distancez( scurve.item(0).getStartPt() ) + 10000));
				factory.setInput( 3, false );
			}
			var srays = factory.calculate();
			
			factory = moi.command.createFactory( 'extend' );
			factory.setInput( 0, srays );
			factory.setInput( 1, obj );
			var erays = factory.calculate();
			
			factory = moi.command.createFactory( 'interpcurve' );
			for ( var i = 0; i < erays.length; ++i )
			{
				factory.createInput('point');
				factory.setInput( i, erays.item(i).getStartPt() );
			}
			if ( scurve.item(0).isClosed && erays.length>0 )
			{
				factory.createInput('point');
				factory.setInput( i, erays.item(0).getStartPt() );
			}
			factory.commit();
			break;
		}
	}
	/* moi.view.setCPlane(sCPlane); */
	moi.view.hiddenLineOpacity = hlo;
	moi.view.showHiddenLines = shl; 
	moi.view.hiddenLineStyle = hls; 
}

DoSketchCurve();
