// config: norepeat

#include "GetObjects.js"

function DoUntrimAll()
{
	// Get some breps to break apart and untrim.
	var objectpicker = moi.ui.createObjectPicker();
	objectpicker.allowBReps();
	if ( !GetObjects( objectpicker ) )
		return;
	
	// First run them through the separate command and grab the results.
	var separatefactory = moi.command.createFactory( 'separate' );
	separatefactory.setInput( 0, objectpicker.objects );
	separatefactory.update();
	var separated = separatefactory.getCreatedObjects();
	separatefactory.commit();
	
	// Now gather all the edges of the separated results.
	var alledges = moi.geometryDatabase.createObjectList();
	for ( var i = 0; i < separated.length; ++i )
	{
		var edges = separated.item(i).getEdges();
		for ( var j = 0; j < edges.length; ++j )
			alledges.addObject( edges.item(j) );
	}

	// Run the edges through the delete command to untrim all the surfaces.	
	var deletefactory = moi.command.createFactory( 'delete' );
	deletefactory.setInput( 0, alledges );
	deletefactory.commit();
}

DoUntrimAll();
