
function DoImageToRect()
{
	var objs = moi.geometryDatabase.getSelectedObjects();
	var have_rect = false;
	var frame, width, height;

	if ( objs.length == 1 )
	{
		var obj = objs.item(0);

		if ( obj.isCurve && obj.isClosed && obj.isPlanar )
		{
			frame = obj.planarFrame;

			var lines = obj.getSubObjects();
			var all_lines = false;

			if ( lines.length == 4 )
			{
				all_lines = true;

				for ( var i = 0; i < lines.length; ++i )
				{
					if ( !lines.item(i).isLine )
					{
						all_lines = false;
						break;
					}
				}
			}

			if ( all_lines )
			{
				var pts = [];
				for ( var i = 0; i < 4; ++i )
					pts.push( lines.item(i).getStartPt() );

				var xmin, ymin, xmax, ymax;
				xmin = xmax = frame.distancex( pts[0] );
				ymin = ymax = frame.distancey( pts[0] );
	
				for ( var i = 1; i < 4; ++i )
				{
					var x = frame.distancex( pts[i] );
					var y = frame.distancey( pts[i] );
					if ( x < xmin ) xmin = x;
					if ( x > xmax ) xmax = x;
					if ( y < ymin ) ymin = y;
					if ( y > ymax ) ymax = y;
				}

				var origin = frame.evaluate( xmin, ymin );
				frame.origin = origin;

				width = xmax - xmin;
				height = ymax - ymin;

				have_rect = true;				
			}
		}
	}

	if ( !have_rect )
	{
		moi.ui.alert( 'Error - one rectangle should be selected' );
		return;
	}

	var factory = moi.command.createFactory( 'backgroundimage' );
	var filename = factory.getOpenFileName();
	
	if ( filename == '' )
		return false;
		
	factory.setInput( 0, filename );
	factory.setInput( 1, frame );
	factory.setInput( 2, frame.evaluate( width, height ) );
	factory.update();
	factory.commit();

	var images = moi.view.getBackgroundImages();
	if ( images.length > 0 )
	{
		var image = images.item( 0 );
		if ( image.fileName == filename )
		{
			image.width = width;
			image.height = height;
		}
	}
}

DoImageToRect();
