script:
var threadDiameter = 10;
var threadPitch = 1.5;
var threadLength = 30;
var alerts = false;

/*draw helix*/
var frame = moi.vectorMath.createTopFrame();
frame.origin = moi.vectorMath.createPoint( 0, 0, -1*threadPitch/2 );
var factory = moi.command.createFactory( 'helix' );
factory.setInput( 0, frame );
factory.setInput( 1, moi.vectorMath.createPoint( 0, 0, threadLength+threadPitch/2 ) );
factory.setInput( 2, moi.vectorMath.createPoint( threadDiameter/2, 0, 0 ) );
factory.setInput( 6, threadLength+1 );
factory.setInput( 7, threadPitch );
factory.setInput( 8, 'flat' );
factory.commit();
moi.geometryDatabase.selectAll();
var rail = moi.geometryDatabase.getSelectedObjects();

/*draw thread cutting profile*/
frame = moi.vectorMath.createFrontFrame();
frame.origin = moi.vectorMath.createPoint( threadDiameter/2, 0, -1*threadPitch );
factory = moi.command.createFactory( 'polygonedge' );
factory.setInput( 0, frame );
factory.setInput( 1, moi.vectorMath.createPoint( threadDiameter/2, 0, 0 ) );
factory.setInput( 2, 3 );
factory.commit();
moi.geometryDatabase.invertSelection();
var profile = moi.geometryDatabase.getSelectedObjects();

if (alerts) moi.ui.commandUI.alert( "rail + profile" );

/*sweep profile along rail*/
moi.geometryDatabase.selectAll();
var list = moi.createList();
list.add( moi.vectorMath.createPoint( 0, 0, 0 ) );
list.add( moi.vectorMath.createPoint( 0, 0, 1 ) );
factory = moi.command.createFactory( 'sweep' );
factory.setInput( 0, profile );
factory.setInput( 1, rail );
factory.setInput( 2, list );
/*Ends:*/ factory.setInput( 4, 'Regular' );
/*Twist:*/ factory.setInput( 5, 'Flat' );
/*Cap ends:*/ factory.setInput( 7, true );
/*Profiles:*/ factory.setInput( 10, 'Exact' );
factory.commit();
moi.geometryDatabase.invertSelection();
var cutter = moi.geometryDatabase.getSelectedObjects();

if (alerts) moi.ui.commandUI.alert( "cutter" );

/*delete rail*/
factory = moi.command.createFactory( 'delete' );
factory.setInput( 0, rail );
factory.commit();

/*delete profile*/
factory = moi.command.createFactory( 'delete' );
factory.setInput( 0, profile );
factory.commit();

/*draw cylinder*/
moi.geometryDatabase.selectAll();
frame = moi.vectorMath.createTopFrame();
frame.origin = moi.vectorMath.createPoint( 0, 0, 0 );
factory = moi.command.createFactory( 'cylinder' );
factory.setInput( 1, frame );
factory.setInput( 3, threadDiameter/2-0.005 );
factory.setInput( 4, moi.vectorMath.createPoint( 0, 0, threadLength ) );
factory.commit();
moi.geometryDatabase.invertSelection();
cylinder = moi.geometryDatabase.getSelectedObjects();

if (alerts) moi.ui.commandUI.alert( "cylinder" );

/*Boolean difference*/
moi.geometryDatabase.deselectAll();
factory = moi.command.createFactory( 'booleandifference' );
factory.setInput( 0, cylinder );
factory.setInput( 1, cutter );
factory.setInput( 2, false );
factory.commit();

moi.geometryDatabase.selectAll();
moi.view.resetAll();

if (alerts) moi.ui.commandUI.alert( "result" );moi
