
function DoMoveInFront()
{
    var sel = moi.geometryDatabase.getSelectedObjects();

    var curves = sel.getStandaloneCurves();
    var breps = sel.getBReps();
    if ( curves.length == 0 )
        return;

    var bbox = (breps.length > 0 ? breps.getBoundingBox() : moi.geometryDatabase.getObjects().getBReps().getBoundingBox());
    var crvbox = curves.getBoundingBox();

    var vp = moi.ui.getActiveViewport();
    if ( vp == null )
        return;

    var dir = (vp.name == '3D' ? vp.cplane.zaxis : vp.cameraFrame.zaxis);


    var dist = 0.0;
    var padding_factor = 0.3;

    if ( dir.x == 0.0 && dir.y == 0.0 )
    {
        if ( dir.z == 1.0 )
            dist = bbox.max.z - crvbox.min.z;
        else
            dist = crvbox.max.z - bbox.min.z;

        dist += bbox.zLength * padding_factor;
    }
    else if ( dir.x == 0.0 && dir.z == 0.0 )
    {
        if ( dir.y == 1.0 )
            dist = bbox.max.y - crvbox.min.y;
        else
            dist = crvbox.max.y - bbox.min.y;

        dist += bbox.yLength * padding_factor;
    }
    else
    {
        if ( dir.x == 1.0 )
            dist = bbox.max.x - crvbox.min.x;
        else
            dist = crvbox.max.x - bbox.min.x;

        dist += bbox.xLength * padding_factor;
    }

    if ( dist < 0.00000001 )
        return;

    var factory = moi.command.createFactory( 'move' );
    factory.setInput( 0, curves );
    factory.setInput( 1, moi.vectorMath.createPoint(0,0,0) );
    factory.setInput( 2, moi.vectorMath.createPoint(dist*dir.x, dist*dir.y, dist*dir.z) );
    factory.commit();
}

DoMoveInFront();
